# coding: utf-8
# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20201101


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class NamedCredential(object):
    """
    The details of a named credential.
    """

    #: A constant which can be used with the lifecycle_state property of a NamedCredential.
    #: This constant has a value of "CREATING"
    LIFECYCLE_STATE_CREATING = "CREATING"

    #: A constant which can be used with the lifecycle_state property of a NamedCredential.
    #: This constant has a value of "UPDATING"
    LIFECYCLE_STATE_UPDATING = "UPDATING"

    #: A constant which can be used with the lifecycle_state property of a NamedCredential.
    #: This constant has a value of "ACTIVE"
    LIFECYCLE_STATE_ACTIVE = "ACTIVE"

    #: A constant which can be used with the lifecycle_state property of a NamedCredential.
    #: This constant has a value of "DELETING"
    LIFECYCLE_STATE_DELETING = "DELETING"

    #: A constant which can be used with the lifecycle_state property of a NamedCredential.
    #: This constant has a value of "DELETED"
    LIFECYCLE_STATE_DELETED = "DELETED"

    #: A constant which can be used with the lifecycle_state property of a NamedCredential.
    #: This constant has a value of "FAILED"
    LIFECYCLE_STATE_FAILED = "FAILED"

    #: A constant which can be used with the scope property of a NamedCredential.
    #: This constant has a value of "RESOURCE"
    SCOPE_RESOURCE = "RESOURCE"

    #: A constant which can be used with the scope property of a NamedCredential.
    #: This constant has a value of "GLOBAL"
    SCOPE_GLOBAL = "GLOBAL"

    #: A constant which can be used with the type property of a NamedCredential.
    #: This constant has a value of "ORACLE_DB"
    TYPE_ORACLE_DB = "ORACLE_DB"

    def __init__(self, **kwargs):
        """
        Initializes a new NamedCredential object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param name:
            The value to assign to the name property of this NamedCredential.
        :type name: str

        :param id:
            The value to assign to the id property of this NamedCredential.
        :type id: str

        :param compartment_id:
            The value to assign to the compartment_id property of this NamedCredential.
        :type compartment_id: str

        :param description:
            The value to assign to the description property of this NamedCredential.
        :type description: str

        :param lifecycle_state:
            The value to assign to the lifecycle_state property of this NamedCredential.
            Allowed values for this property are: "CREATING", "UPDATING", "ACTIVE", "DELETING", "DELETED", "FAILED", 'UNKNOWN_ENUM_VALUE'.
            Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.
        :type lifecycle_state: str

        :param lifecycle_details:
            The value to assign to the lifecycle_details property of this NamedCredential.
        :type lifecycle_details: str

        :param scope:
            The value to assign to the scope property of this NamedCredential.
            Allowed values for this property are: "RESOURCE", "GLOBAL", 'UNKNOWN_ENUM_VALUE'.
            Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.
        :type scope: str

        :param type:
            The value to assign to the type property of this NamedCredential.
            Allowed values for this property are: "ORACLE_DB", 'UNKNOWN_ENUM_VALUE'.
            Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.
        :type type: str

        :param content:
            The value to assign to the content property of this NamedCredential.
        :type content: oci.database_management.models.NamedCredentialContent

        :param time_created:
            The value to assign to the time_created property of this NamedCredential.
        :type time_created: datetime

        :param time_updated:
            The value to assign to the time_updated property of this NamedCredential.
        :type time_updated: datetime

        :param associated_resource:
            The value to assign to the associated_resource property of this NamedCredential.
        :type associated_resource: str

        """
        self.swagger_types = {
            'name': 'str',
            'id': 'str',
            'compartment_id': 'str',
            'description': 'str',
            'lifecycle_state': 'str',
            'lifecycle_details': 'str',
            'scope': 'str',
            'type': 'str',
            'content': 'NamedCredentialContent',
            'time_created': 'datetime',
            'time_updated': 'datetime',
            'associated_resource': 'str'
        }

        self.attribute_map = {
            'name': 'name',
            'id': 'id',
            'compartment_id': 'compartmentId',
            'description': 'description',
            'lifecycle_state': 'lifecycleState',
            'lifecycle_details': 'lifecycleDetails',
            'scope': 'scope',
            'type': 'type',
            'content': 'content',
            'time_created': 'timeCreated',
            'time_updated': 'timeUpdated',
            'associated_resource': 'associatedResource'
        }

        self._name = None
        self._id = None
        self._compartment_id = None
        self._description = None
        self._lifecycle_state = None
        self._lifecycle_details = None
        self._scope = None
        self._type = None
        self._content = None
        self._time_created = None
        self._time_updated = None
        self._associated_resource = None

    @property
    def name(self):
        """
        **[Required]** Gets the name of this NamedCredential.
        The name of the named credential.


        :return: The name of this NamedCredential.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this NamedCredential.
        The name of the named credential.


        :param name: The name of this NamedCredential.
        :type: str
        """
        self._name = name

    @property
    def id(self):
        """
        **[Required]** Gets the id of this NamedCredential.
        The `OCID`__ of the named credential.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The id of this NamedCredential.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this NamedCredential.
        The `OCID`__ of the named credential.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param id: The id of this NamedCredential.
        :type: str
        """
        self._id = id

    @property
    def compartment_id(self):
        """
        **[Required]** Gets the compartment_id of this NamedCredential.
        The `OCID`__ of the compartment.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The compartment_id of this NamedCredential.
        :rtype: str
        """
        return self._compartment_id

    @compartment_id.setter
    def compartment_id(self, compartment_id):
        """
        Sets the compartment_id of this NamedCredential.
        The `OCID`__ of the compartment.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param compartment_id: The compartment_id of this NamedCredential.
        :type: str
        """
        self._compartment_id = compartment_id

    @property
    def description(self):
        """
        Gets the description of this NamedCredential.
        The information specified by the user about the named credential.


        :return: The description of this NamedCredential.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this NamedCredential.
        The information specified by the user about the named credential.


        :param description: The description of this NamedCredential.
        :type: str
        """
        self._description = description

    @property
    def lifecycle_state(self):
        """
        **[Required]** Gets the lifecycle_state of this NamedCredential.
        The current lifecycle state of the named credential.

        Allowed values for this property are: "CREATING", "UPDATING", "ACTIVE", "DELETING", "DELETED", "FAILED", 'UNKNOWN_ENUM_VALUE'.
        Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.


        :return: The lifecycle_state of this NamedCredential.
        :rtype: str
        """
        return self._lifecycle_state

    @lifecycle_state.setter
    def lifecycle_state(self, lifecycle_state):
        """
        Sets the lifecycle_state of this NamedCredential.
        The current lifecycle state of the named credential.


        :param lifecycle_state: The lifecycle_state of this NamedCredential.
        :type: str
        """
        allowed_values = ["CREATING", "UPDATING", "ACTIVE", "DELETING", "DELETED", "FAILED"]
        if not value_allowed_none_or_none_sentinel(lifecycle_state, allowed_values):
            lifecycle_state = 'UNKNOWN_ENUM_VALUE'
        self._lifecycle_state = lifecycle_state

    @property
    def lifecycle_details(self):
        """
        Gets the lifecycle_details of this NamedCredential.
        The details of the lifecycle state.


        :return: The lifecycle_details of this NamedCredential.
        :rtype: str
        """
        return self._lifecycle_details

    @lifecycle_details.setter
    def lifecycle_details(self, lifecycle_details):
        """
        Sets the lifecycle_details of this NamedCredential.
        The details of the lifecycle state.


        :param lifecycle_details: The lifecycle_details of this NamedCredential.
        :type: str
        """
        self._lifecycle_details = lifecycle_details

    @property
    def scope(self):
        """
        Gets the scope of this NamedCredential.
        The scope of the named credential.

        Allowed values for this property are: "RESOURCE", "GLOBAL", 'UNKNOWN_ENUM_VALUE'.
        Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.


        :return: The scope of this NamedCredential.
        :rtype: str
        """
        return self._scope

    @scope.setter
    def scope(self, scope):
        """
        Sets the scope of this NamedCredential.
        The scope of the named credential.


        :param scope: The scope of this NamedCredential.
        :type: str
        """
        allowed_values = ["RESOURCE", "GLOBAL"]
        if not value_allowed_none_or_none_sentinel(scope, allowed_values):
            scope = 'UNKNOWN_ENUM_VALUE'
        self._scope = scope

    @property
    def type(self):
        """
        Gets the type of this NamedCredential.
        The type of resource associated with the named credential.

        Allowed values for this property are: "ORACLE_DB", 'UNKNOWN_ENUM_VALUE'.
        Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.


        :return: The type of this NamedCredential.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this NamedCredential.
        The type of resource associated with the named credential.


        :param type: The type of this NamedCredential.
        :type: str
        """
        allowed_values = ["ORACLE_DB"]
        if not value_allowed_none_or_none_sentinel(type, allowed_values):
            type = 'UNKNOWN_ENUM_VALUE'
        self._type = type

    @property
    def content(self):
        """
        Gets the content of this NamedCredential.

        :return: The content of this NamedCredential.
        :rtype: oci.database_management.models.NamedCredentialContent
        """
        return self._content

    @content.setter
    def content(self, content):
        """
        Sets the content of this NamedCredential.

        :param content: The content of this NamedCredential.
        :type: oci.database_management.models.NamedCredentialContent
        """
        self._content = content

    @property
    def time_created(self):
        """
        **[Required]** Gets the time_created of this NamedCredential.
        The date and time the named credential was created.


        :return: The time_created of this NamedCredential.
        :rtype: datetime
        """
        return self._time_created

    @time_created.setter
    def time_created(self, time_created):
        """
        Sets the time_created of this NamedCredential.
        The date and time the named credential was created.


        :param time_created: The time_created of this NamedCredential.
        :type: datetime
        """
        self._time_created = time_created

    @property
    def time_updated(self):
        """
        Gets the time_updated of this NamedCredential.
        The date and time the named credential was last updated.


        :return: The time_updated of this NamedCredential.
        :rtype: datetime
        """
        return self._time_updated

    @time_updated.setter
    def time_updated(self, time_updated):
        """
        Sets the time_updated of this NamedCredential.
        The date and time the named credential was last updated.


        :param time_updated: The time_updated of this NamedCredential.
        :type: datetime
        """
        self._time_updated = time_updated

    @property
    def associated_resource(self):
        """
        Gets the associated_resource of this NamedCredential.
        The `OCID`__ of the resource that
        is associated to the named credential.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The associated_resource of this NamedCredential.
        :rtype: str
        """
        return self._associated_resource

    @associated_resource.setter
    def associated_resource(self, associated_resource):
        """
        Sets the associated_resource of this NamedCredential.
        The `OCID`__ of the resource that
        is associated to the named credential.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param associated_resource: The associated_resource of this NamedCredential.
        :type: str
        """
        self._associated_resource = associated_resource

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
