# coding: utf-8
# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20230301

from __future__ import absolute_import

from .change_private_endpoint_compartment_details import ChangePrivateEndpointCompartmentDetails
from .change_sharded_database_compartment_details import ChangeShardedDatabaseCompartmentDetails
from .configure_sharded_database_gsms_details import ConfigureShardedDatabaseGsmsDetails
from .connection_string import ConnectionString
from .create_dedicated_catalog_detail import CreateDedicatedCatalogDetail
from .create_dedicated_shard_detail import CreateDedicatedShardDetail
from .create_dedicated_sharded_database import CreateDedicatedShardedDatabase
from .create_private_endpoint_details import CreatePrivateEndpointDetails
from .create_sharded_database_details import CreateShardedDatabaseDetails
from .dedicated_catalog_details import DedicatedCatalogDetails
from .dedicated_shard_details import DedicatedShardDetails
from .dedicated_shard_or_catalog_encryption_key_details import DedicatedShardOrCatalogEncryptionKeyDetails
from .dedicated_sharded_database import DedicatedShardedDatabase
from .dedicated_sharded_database_summary import DedicatedShardedDatabaseSummary
from .fetch_shardable_cloud_autonomous_vm_clusters_details import FetchShardableCloudAutonomousVmClustersDetails
from .generate_wallet_details import GenerateWalletDetails
from .gsm_details import GsmDetails
from .patch_insert_instruction import PatchInsertInstruction
from .patch_instruction import PatchInstruction
from .patch_merge_instruction import PatchMergeInstruction
from .patch_remove_instruction import PatchRemoveInstruction
from .patch_sharded_database_details import PatchShardedDatabaseDetails
from .prevalidate_create_payload import PrevalidateCreatePayload
from .prevalidate_patch_payload import PrevalidatePatchPayload
from .prevalidate_payload import PrevalidatePayload
from .prevalidate_sharded_database_details import PrevalidateShardedDatabaseDetails
from .prevalidate_sharded_database_result import PrevalidateShardedDatabaseResult
from .private_endpoint import PrivateEndpoint
from .private_endpoint_collection import PrivateEndpointCollection
from .private_endpoint_summary import PrivateEndpointSummary
from .shardable_cloud_autonomous_vm_cluster_summary import ShardableCloudAutonomousVmClusterSummary
from .shardable_cloud_autonomous_vm_clusters import ShardableCloudAutonomousVmClusters
from .sharded_database import ShardedDatabase
from .sharded_database_collection import ShardedDatabaseCollection
from .sharded_database_summary import ShardedDatabaseSummary
from .update_private_endpoint_details import UpdatePrivateEndpointDetails
from .update_sharded_database_details import UpdateShardedDatabaseDetails
from .upload_signed_certificate_and_generate_wallet_details import UploadSignedCertificateAndGenerateWalletDetails
from .work_request import WorkRequest
from .work_request_error import WorkRequestError
from .work_request_error_collection import WorkRequestErrorCollection
from .work_request_log_entry import WorkRequestLogEntry
from .work_request_log_entry_collection import WorkRequestLogEntryCollection
from .work_request_resource import WorkRequestResource
from .work_request_summary import WorkRequestSummary
from .work_request_summary_collection import WorkRequestSummaryCollection

# Maps type names to classes for globally_distributed_database services.
globally_distributed_database_type_mapping = {
    "ChangePrivateEndpointCompartmentDetails": ChangePrivateEndpointCompartmentDetails,
    "ChangeShardedDatabaseCompartmentDetails": ChangeShardedDatabaseCompartmentDetails,
    "ConfigureShardedDatabaseGsmsDetails": ConfigureShardedDatabaseGsmsDetails,
    "ConnectionString": ConnectionString,
    "CreateDedicatedCatalogDetail": CreateDedicatedCatalogDetail,
    "CreateDedicatedShardDetail": CreateDedicatedShardDetail,
    "CreateDedicatedShardedDatabase": CreateDedicatedShardedDatabase,
    "CreatePrivateEndpointDetails": CreatePrivateEndpointDetails,
    "CreateShardedDatabaseDetails": CreateShardedDatabaseDetails,
    "DedicatedCatalogDetails": DedicatedCatalogDetails,
    "DedicatedShardDetails": DedicatedShardDetails,
    "DedicatedShardOrCatalogEncryptionKeyDetails": DedicatedShardOrCatalogEncryptionKeyDetails,
    "DedicatedShardedDatabase": DedicatedShardedDatabase,
    "DedicatedShardedDatabaseSummary": DedicatedShardedDatabaseSummary,
    "FetchShardableCloudAutonomousVmClustersDetails": FetchShardableCloudAutonomousVmClustersDetails,
    "GenerateWalletDetails": GenerateWalletDetails,
    "GsmDetails": GsmDetails,
    "PatchInsertInstruction": PatchInsertInstruction,
    "PatchInstruction": PatchInstruction,
    "PatchMergeInstruction": PatchMergeInstruction,
    "PatchRemoveInstruction": PatchRemoveInstruction,
    "PatchShardedDatabaseDetails": PatchShardedDatabaseDetails,
    "PrevalidateCreatePayload": PrevalidateCreatePayload,
    "PrevalidatePatchPayload": PrevalidatePatchPayload,
    "PrevalidatePayload": PrevalidatePayload,
    "PrevalidateShardedDatabaseDetails": PrevalidateShardedDatabaseDetails,
    "PrevalidateShardedDatabaseResult": PrevalidateShardedDatabaseResult,
    "PrivateEndpoint": PrivateEndpoint,
    "PrivateEndpointCollection": PrivateEndpointCollection,
    "PrivateEndpointSummary": PrivateEndpointSummary,
    "ShardableCloudAutonomousVmClusterSummary": ShardableCloudAutonomousVmClusterSummary,
    "ShardableCloudAutonomousVmClusters": ShardableCloudAutonomousVmClusters,
    "ShardedDatabase": ShardedDatabase,
    "ShardedDatabaseCollection": ShardedDatabaseCollection,
    "ShardedDatabaseSummary": ShardedDatabaseSummary,
    "UpdatePrivateEndpointDetails": UpdatePrivateEndpointDetails,
    "UpdateShardedDatabaseDetails": UpdateShardedDatabaseDetails,
    "UploadSignedCertificateAndGenerateWalletDetails": UploadSignedCertificateAndGenerateWalletDetails,
    "WorkRequest": WorkRequest,
    "WorkRequestError": WorkRequestError,
    "WorkRequestErrorCollection": WorkRequestErrorCollection,
    "WorkRequestLogEntry": WorkRequestLogEntry,
    "WorkRequestLogEntryCollection": WorkRequestLogEntryCollection,
    "WorkRequestResource": WorkRequestResource,
    "WorkRequestSummary": WorkRequestSummary,
    "WorkRequestSummaryCollection": WorkRequestSummaryCollection
}
