# coding: utf-8
# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20230601


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class CreateJavaDownloadTokenDetails(object):
    """
    The attributes to create a new JavaDownloadToken.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new CreateJavaDownloadTokenDetails object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param display_name:
            The value to assign to the display_name property of this CreateJavaDownloadTokenDetails.
        :type display_name: str

        :param description:
            The value to assign to the description property of this CreateJavaDownloadTokenDetails.
        :type description: str

        :param compartment_id:
            The value to assign to the compartment_id property of this CreateJavaDownloadTokenDetails.
        :type compartment_id: str

        :param is_default:
            The value to assign to the is_default property of this CreateJavaDownloadTokenDetails.
        :type is_default: bool

        :param time_expires:
            The value to assign to the time_expires property of this CreateJavaDownloadTokenDetails.
        :type time_expires: datetime

        :param java_version:
            The value to assign to the java_version property of this CreateJavaDownloadTokenDetails.
        :type java_version: str

        :param license_type:
            The value to assign to the license_type property of this CreateJavaDownloadTokenDetails.
        :type license_type: list[oci.jms_java_downloads.models.LicenseType]

        :param freeform_tags:
            The value to assign to the freeform_tags property of this CreateJavaDownloadTokenDetails.
        :type freeform_tags: dict(str, str)

        :param defined_tags:
            The value to assign to the defined_tags property of this CreateJavaDownloadTokenDetails.
        :type defined_tags: dict(str, dict(str, object))

        """
        self.swagger_types = {
            'display_name': 'str',
            'description': 'str',
            'compartment_id': 'str',
            'is_default': 'bool',
            'time_expires': 'datetime',
            'java_version': 'str',
            'license_type': 'list[LicenseType]',
            'freeform_tags': 'dict(str, str)',
            'defined_tags': 'dict(str, dict(str, object))'
        }

        self.attribute_map = {
            'display_name': 'displayName',
            'description': 'description',
            'compartment_id': 'compartmentId',
            'is_default': 'isDefault',
            'time_expires': 'timeExpires',
            'java_version': 'javaVersion',
            'license_type': 'licenseType',
            'freeform_tags': 'freeformTags',
            'defined_tags': 'definedTags'
        }

        self._display_name = None
        self._description = None
        self._compartment_id = None
        self._is_default = None
        self._time_expires = None
        self._java_version = None
        self._license_type = None
        self._freeform_tags = None
        self._defined_tags = None

    @property
    def display_name(self):
        """
        **[Required]** Gets the display_name of this CreateJavaDownloadTokenDetails.
        User provided display name of the JavaDownloadToken.


        :return: The display_name of this CreateJavaDownloadTokenDetails.
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """
        Sets the display_name of this CreateJavaDownloadTokenDetails.
        User provided display name of the JavaDownloadToken.


        :param display_name: The display_name of this CreateJavaDownloadTokenDetails.
        :type: str
        """
        self._display_name = display_name

    @property
    def description(self):
        """
        **[Required]** Gets the description of this CreateJavaDownloadTokenDetails.
        User provided description of the JavaDownloadToken.


        :return: The description of this CreateJavaDownloadTokenDetails.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this CreateJavaDownloadTokenDetails.
        User provided description of the JavaDownloadToken.


        :param description: The description of this CreateJavaDownloadTokenDetails.
        :type: str
        """
        self._description = description

    @property
    def compartment_id(self):
        """
        **[Required]** Gets the compartment_id of this CreateJavaDownloadTokenDetails.
        The `OCID`__ of the tenancy scoped to the JavaDownloadToken.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The compartment_id of this CreateJavaDownloadTokenDetails.
        :rtype: str
        """
        return self._compartment_id

    @compartment_id.setter
    def compartment_id(self, compartment_id):
        """
        Sets the compartment_id of this CreateJavaDownloadTokenDetails.
        The `OCID`__ of the tenancy scoped to the JavaDownloadToken.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param compartment_id: The compartment_id of this CreateJavaDownloadTokenDetails.
        :type: str
        """
        self._compartment_id = compartment_id

    @property
    def is_default(self):
        """
        Gets the is_default of this CreateJavaDownloadTokenDetails.
        The token default attribute.


        :return: The is_default of this CreateJavaDownloadTokenDetails.
        :rtype: bool
        """
        return self._is_default

    @is_default.setter
    def is_default(self, is_default):
        """
        Sets the is_default of this CreateJavaDownloadTokenDetails.
        The token default attribute.


        :param is_default: The is_default of this CreateJavaDownloadTokenDetails.
        :type: bool
        """
        self._is_default = is_default

    @property
    def time_expires(self):
        """
        **[Required]** Gets the time_expires of this CreateJavaDownloadTokenDetails.
        Expiry time of the token.


        :return: The time_expires of this CreateJavaDownloadTokenDetails.
        :rtype: datetime
        """
        return self._time_expires

    @time_expires.setter
    def time_expires(self, time_expires):
        """
        Sets the time_expires of this CreateJavaDownloadTokenDetails.
        Expiry time of the token.


        :param time_expires: The time_expires of this CreateJavaDownloadTokenDetails.
        :type: datetime
        """
        self._time_expires = time_expires

    @property
    def java_version(self):
        """
        **[Required]** Gets the java_version of this CreateJavaDownloadTokenDetails.
        The Java version associated with the token.


        :return: The java_version of this CreateJavaDownloadTokenDetails.
        :rtype: str
        """
        return self._java_version

    @java_version.setter
    def java_version(self, java_version):
        """
        Sets the java_version of this CreateJavaDownloadTokenDetails.
        The Java version associated with the token.


        :param java_version: The java_version of this CreateJavaDownloadTokenDetails.
        :type: str
        """
        self._java_version = java_version

    @property
    def license_type(self):
        """
        **[Required]** Gets the license_type of this CreateJavaDownloadTokenDetails.
        The license type(s) associated with the JavaDownloadToken.


        :return: The license_type of this CreateJavaDownloadTokenDetails.
        :rtype: list[oci.jms_java_downloads.models.LicenseType]
        """
        return self._license_type

    @license_type.setter
    def license_type(self, license_type):
        """
        Sets the license_type of this CreateJavaDownloadTokenDetails.
        The license type(s) associated with the JavaDownloadToken.


        :param license_type: The license_type of this CreateJavaDownloadTokenDetails.
        :type: list[oci.jms_java_downloads.models.LicenseType]
        """
        self._license_type = license_type

    @property
    def freeform_tags(self):
        """
        Gets the freeform_tags of this CreateJavaDownloadTokenDetails.
        Simple key-value pair that is applied without any predefined name, type, or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`. (See `Managing Tags and Tag Namespaces`__.)

        __ https://docs.cloud.oracle.com/Content/Tagging/Concepts/understandingfreeformtags.htm


        :return: The freeform_tags of this CreateJavaDownloadTokenDetails.
        :rtype: dict(str, str)
        """
        return self._freeform_tags

    @freeform_tags.setter
    def freeform_tags(self, freeform_tags):
        """
        Sets the freeform_tags of this CreateJavaDownloadTokenDetails.
        Simple key-value pair that is applied without any predefined name, type, or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`. (See `Managing Tags and Tag Namespaces`__.)

        __ https://docs.cloud.oracle.com/Content/Tagging/Concepts/understandingfreeformtags.htm


        :param freeform_tags: The freeform_tags of this CreateJavaDownloadTokenDetails.
        :type: dict(str, str)
        """
        self._freeform_tags = freeform_tags

    @property
    def defined_tags(self):
        """
        Gets the defined_tags of this CreateJavaDownloadTokenDetails.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`. (See `Understanding Free-form Tags`__).

        __ https://docs.cloud.oracle.com/Content/Tagging/Tasks/managingtagsandtagnamespaces.htm


        :return: The defined_tags of this CreateJavaDownloadTokenDetails.
        :rtype: dict(str, dict(str, object))
        """
        return self._defined_tags

    @defined_tags.setter
    def defined_tags(self, defined_tags):
        """
        Sets the defined_tags of this CreateJavaDownloadTokenDetails.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`. (See `Understanding Free-form Tags`__).

        __ https://docs.cloud.oracle.com/Content/Tagging/Tasks/managingtagsandtagnamespaces.htm


        :param defined_tags: The defined_tags of this CreateJavaDownloadTokenDetails.
        :type: dict(str, dict(str, object))
        """
        self._defined_tags = defined_tags

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
