# coding: utf-8
# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20210330

from .create_config_details import CreateConfigDetails
from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class CreateAutoPromoteConfigDetails(CreateConfigDetails):
    """
    The details of an AUTO_PROMOTE configuration.
    """

    #: A constant which can be used with the resource_type property of a CreateAutoPromoteConfigDetails.
    #: This constant has a value of "HOST"
    RESOURCE_TYPE_HOST = "HOST"

    def __init__(self, **kwargs):
        """
        Initializes a new CreateAutoPromoteConfigDetails object with values from keyword arguments. The default value of the :py:attr:`~oci.stack_monitoring.models.CreateAutoPromoteConfigDetails.config_type` attribute
        of this class is ``AUTO_PROMOTE`` and it should not be changed.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param display_name:
            The value to assign to the display_name property of this CreateAutoPromoteConfigDetails.
        :type display_name: str

        :param compartment_id:
            The value to assign to the compartment_id property of this CreateAutoPromoteConfigDetails.
        :type compartment_id: str

        :param config_type:
            The value to assign to the config_type property of this CreateAutoPromoteConfigDetails.
        :type config_type: str

        :param freeform_tags:
            The value to assign to the freeform_tags property of this CreateAutoPromoteConfigDetails.
        :type freeform_tags: dict(str, str)

        :param defined_tags:
            The value to assign to the defined_tags property of this CreateAutoPromoteConfigDetails.
        :type defined_tags: dict(str, dict(str, object))

        :param resource_type:
            The value to assign to the resource_type property of this CreateAutoPromoteConfigDetails.
            Allowed values for this property are: "HOST"
        :type resource_type: str

        :param is_enabled:
            The value to assign to the is_enabled property of this CreateAutoPromoteConfigDetails.
        :type is_enabled: bool

        """
        self.swagger_types = {
            'display_name': 'str',
            'compartment_id': 'str',
            'config_type': 'str',
            'freeform_tags': 'dict(str, str)',
            'defined_tags': 'dict(str, dict(str, object))',
            'resource_type': 'str',
            'is_enabled': 'bool'
        }

        self.attribute_map = {
            'display_name': 'displayName',
            'compartment_id': 'compartmentId',
            'config_type': 'configType',
            'freeform_tags': 'freeformTags',
            'defined_tags': 'definedTags',
            'resource_type': 'resourceType',
            'is_enabled': 'isEnabled'
        }

        self._display_name = None
        self._compartment_id = None
        self._config_type = None
        self._freeform_tags = None
        self._defined_tags = None
        self._resource_type = None
        self._is_enabled = None
        self._config_type = 'AUTO_PROMOTE'

    @property
    def resource_type(self):
        """
        **[Required]** Gets the resource_type of this CreateAutoPromoteConfigDetails.
        The type of resource to configure for automatic promotion.

        Allowed values for this property are: "HOST"


        :return: The resource_type of this CreateAutoPromoteConfigDetails.
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """
        Sets the resource_type of this CreateAutoPromoteConfigDetails.
        The type of resource to configure for automatic promotion.


        :param resource_type: The resource_type of this CreateAutoPromoteConfigDetails.
        :type: str
        """
        allowed_values = ["HOST"]
        if not value_allowed_none_or_none_sentinel(resource_type, allowed_values):
            raise ValueError(
                f"Invalid value for `resource_type`, must be None or one of {allowed_values}"
            )
        self._resource_type = resource_type

    @property
    def is_enabled(self):
        """
        **[Required]** Gets the is_enabled of this CreateAutoPromoteConfigDetails.
        True if automatic promotion is enabled, false if it is not enabled.


        :return: The is_enabled of this CreateAutoPromoteConfigDetails.
        :rtype: bool
        """
        return self._is_enabled

    @is_enabled.setter
    def is_enabled(self, is_enabled):
        """
        Sets the is_enabled of this CreateAutoPromoteConfigDetails.
        True if automatic promotion is enabled, false if it is not enabled.


        :param is_enabled: The is_enabled of this CreateAutoPromoteConfigDetails.
        :type: bool
        """
        self._is_enabled = is_enabled

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
